<?php
namespace nur\sery\schema\input;

/**
 * Class PostInput: accès à des paramètres de formulaire de type POST uniquement
 *
 * cette implémentation lit depuis les paramètres de formulaire et écrit dans
 * une référence
 */
class PostInput extends FormInput {
  function isPresent($key=null): bool {
    if ($key === null) return false;
    return array_key_exists($key, $_POST);
  }

  function isAvailable($key=null): bool {
    if ($key === null) return false;
    if (array_key_exists($key, $_POST)) {
      return $this->allowEmpty || $_POST[$key] !== "";
    } else {
      return false;
    }
  }

  function get($key=null) {
    if ($key === null) return null;
    if (array_key_exists($key, $_POST)) {
      $value = $_POST[$key];
      if ($value === "" && !$this->allowEmpty) return null;
      return $value;
    } else {
      return null;
    }
  }
}
